#ifndef _SURFACE_FORMAT_H
#define _SURFACE_FORMAT_H


#define SURFACE_FORMAT_TIMESTAMP  "2015-09-16 16:40:28"
typedef enum
{
    HSF_UNKNOWN                   = 0,
    HSF_R64G64B64A64_FLOAT        = 1,
    HSF_R64G64B64_FLOAT           = 2,
    HSF_R32G32B32A32_TYPELESS     = 3,
    HSF_R32G32B32A32_FLOAT        = 4,		
    HSF_R32G32B32A32_UINT         = 5,
    HSF_R32G32B32A32_SINT         = 6,
    HSF_R32G32B32A32_SNORM        = 7,
    HSF_R32G32B32A32_SCALE        = 8,
    HSF_R32G32B32A32_UNORM        = 9,
    HSF_R32G32B32A32_USCALE       = 10,
    HSF_R32G32B32A32_FIX          = 11,
    HSF_R64G64_FLOAT              = 12,
    HSF_R32G32B32_TYPELESS        = 13,
    HSF_R32G32B32_FLOAT           = 14,     
    HSF_R32G32B32_UINT            = 15,
    HSF_R32G32B32_SINT            = 16,
    HSF_R32G32B32_UNORM           = 17,
    HSF_R32G32B32_USCALE          = 18,
    HSF_R32G32B32_SNORM           = 19,
    HSF_R32G32B32_SCALE           = 20,
    HSF_R32G32B32_FIX             = 21,
    HSF_R16G16B16A16_TYPELESS     = 22,		
    HSF_R16G16B16A16_FLOAT        = 23,
    HSF_R16G16B16A16_UNORM        = 24,
    HSF_R16G16B16A16_UINT         = 25,
    HSF_R16G16B16A16_SNORM        = 26,
    HSF_R16G16B16A16_SINT         = 27,
    HSF_R16G16B16A16_SCALE        = 28,
    HSF_R16G16B16A16_USCALE       = 29,
    HSF_R16G16B16A16_SSCALE       = 30,
    HSF_R12G12B12A12_UNORM        = 31,
    HSF_R16G16B16_FLOAT           = 32,		
    HSF_R16G16B16_SINT            = 33,
    HSF_R16G16B16_SNORM           = 34,
    HSF_R16G16B16_SCALE           = 35,
    HSF_R16G16B16_UINT            = 36,
    HSF_R16G16B16_UNORM           = 37,
    HSF_R16G16B16_USCALE          = 38,
    HSF_R32G32_TYPELESS           = 39,
    HSF_R32G32_FLOAT              = 40,		
    HSF_R32G32_UINT               = 41,
    HSF_R32G32_SINT               = 42,
    HSF_R32G32_SNORM              = 43,
    HSF_R32G32_SCALE              = 44,
    HSF_R32G32_UNORM              = 45,
    HSF_R32G32_USCALE             = 46,
    HSF_R32G32_FIX                = 47,
    HSF_R32G8X24_TYPELESS         = 48,
    HSF_D32_FLOAT_S8X24_UINT      = 49,
    HSF_R32_FLOAT_X8X24_TYPELESS  = 50,
    HSF_X32_TYPELESS_G8X24_UINT   = 51,
    HSF_R64_FLOAT                 = 52,
    HSF_R12G12B12_UNORM           = 53,
    HSF_R10G10B10A2_TYPELESS      = 54,
    HSF_R10G10B10A2_UNORM         = 55,		
    HSF_R10G10B10A2_UINT          = 56,
    HSF_R10G10B10X2_UINT          = 57,     
    HSF_R10G10B10X2_USCALE        = 58,
    HSF_R10G10B10A2_SNORM         = 59,
    HSF_R10G10B10A2_SINT          = 60,
    HSF_R10G10B10X2_SNORM         = 61,
    HSF_B10G10R10A2_SNORM         = 62,
    HSF_B10G10R10A2_UNORM         = 63,
    HSF_B10G10R10X2_UNORM         = 64,
    HSF_A2B10G10R10_UNORM         = 65,
    HSF_A2B10G10R10_SNORM         = 66,
    HSF_A2B10G10R10_USCALE        = 67,
    HSF_A2B10G10R10_SSCALE        = 68,
    HSF_R10G10B10_SINT            = 69,
    HSF_R10G10B10_SNORM           = 70,
    HSF_R10G10B10_SCALE           = 71,
    HSF_R10G10B10_UNIT            = 72,
    HSF_R10G10B10_UNORM           = 73,
    HSF_R10G10B10_USCALE          = 74,
    HSF_R10G10_SINT               = 75,
    HSF_R10G10_SNORM              = 76,
    HSF_R10G10_SCALE              = 77,
    HSF_R10G10_UINT               = 78,
    HSF_R10G10_UNORM              = 79,
    HSF_R10G10_USCALE             = 80,
    HSF_R10G10B10_FLOAT_A2_UNORM  = 81,
    HSF_R11G11B10_FLOAT           = 82,		
    HSF_B10G11R11_FLOAT           = 83,
    HSF_R11G11_FLOAT              = 84,
    HSF_R8G8B8A8_TYPELESS         = 85,
    HSF_R8G8B8A8_UNORM            = 86,		
    HSF_R8G8B8A8_UNORM_SRGB       = 87,
    HSF_R8G8B8X8_UNORM            = 88,		
    HSF_B8G8R8A8_UNORM            = 89,
    HSF_B8G8R8A8_UNORM_SRGB       = 90,
    HSF_B8G8R8X8_UNORM            = 91,
    HSF_B8G8R8X8_UNORM_SRGB       = 92,
    HSF_X8R8G8B8_UNORM            = 93,
    HSF_X8B8G8R8_UNORM            = 94,
    HSF_A8R8G8B8_UNORM            = 95,
    HSF_A8B8G8R8_UNORM            = 96,
    HSF_R8G8B8A8_UINT             = 97,
    HSF_R8G8B8A8_SNORM            = 98,
    HSF_R8G8B8A8_SINT             = 99,
    HSF_B8G8R8A8_XNORM            = 100,
    HSF_R8G8B8A8_SSCALE           = 101,
    HSF_R8G8B8A8_USCALE           = 102,
    HSF_R8G8B8_SINT               = 103,
    HSF_R8G8B8_SNORM              = 104,
    HSF_R8G8B8_SCALE              = 105,
    HSF_R8G8B8_UINT               = 106,
    HSF_R8G8B8_UNORM              = 107,
    HSF_R8G8B8_USCALE             = 108,
    HSF_R16G16_TYPELESS           = 109,
    HSF_R16G16_FLOAT              = 110,		
    HSF_R16G16_UNORM              = 111,
    HSF_R16G16_UINT               = 112,
    HSF_R16G16_SNORM              = 113,
    HSF_R16G16_SINT               = 114,
    HSF_R16G16_SCALE              = 115,
    HSF_R16G16_USCALE             = 116,
    HSF_R16G16_SSCALE             = 117,
    HSF_R32_TYPELESS              = 118,
    HSF_D32_FLOAT                 = 119,
    HSF_D32_UNORM                 = 120,		
    HSF_R32_FLOAT                 = 121,
    HSF_R32_UINT                  = 122,
    HSF_R32_SINT                  = 123,
    HSF_R32_UNORM                 = 124,
    HSF_R32_USCALE                = 125,
    HSF_R32_SNORM                 = 126,
    HSF_R32_SCALE                 = 127,
    HSF_R32_FIX                   = 128,
    HSF_R24G8_TYPELESS            = 129,
    HSF_D32_FLOAT_S8_UINT         = 130,
    HSF_R24_UNORM_X8_TYPELESS     = 132,
    HSF_X24_TYPELESS_G8_UINT      = 133,
    HSF_D24_UNORM                 = 134,
    HSF_R24_FLOAT                 = 135,
    HSF_R8G8_TYPELESS             = 136,
    HSF_R8G8_UNORM                = 137,
    HSF_R8G8_UINT                 = 138,
    HSF_R8G8_SNORM                = 139,
    HSF_R8G8_SINT                 = 140,
    HSF_R8G8_USCALE               = 141,
    HSF_R8G8_SSCALE               = 142,
    HSF_R16_TYPELESS              = 143,
    HSF_R16_FLOAT                 = 144,		
    HSF_D16_UNORM                 = 145,
    HSF_R16_UNORM                 = 146,
    HSF_R16_UINT                  = 147,
    HSF_R16_SNORM                 = 148,
    HSF_R16_SINT                  = 149,
    HSF_R16_USCALE                = 150,
    HSF_R16_SSCALE                = 151,
    HSF_A16_UNORM                 = 152,
    HSF_B5G6R5_UNORM              = 153,
    HSF_R5G6B5_UNORM              = 154,
    HSF_B5G5R5X1_UNORM            = 155,		
    HSF_B5G5R5A1_UNORM            = 156,		
    HSF_R5G5B5A1_UNORM            = 157,
    HSF_A1B5G5R5_UNORM            = 158,
    HSF_A1R5G5B5_UNORM            = 159,
    HSF_B4G4R4A4_UNORM            = 160,
    HSF_B4G4R4X4_UNORM            = 161,		
    HSF_R4G4B4A4_UNORM            = 162,		
    HSF_A4B4G4R4_UNORM            = 163,
    HSF_A4R4G4B4_UNORM            = 164,
    HSF_R4G4B4_UNORM              = 165,
    HSF_R5G5B5_UNORM              = 166,
    HSF_U5V5L6_XNORM              = 167,
    HSF_L16_UNORM                 = 168,		
    HSF_L8_A8_UNORM               = 169,
    HSF_R10_SINT                  = 170,
    HSF_R10_SNORM                 = 171,
    HSF_R10_SCALE                 = 172,
    HSF_R10_UINT                  = 173,
    HSF_R10_UNORM                 = 174,
    HSF_R10_USCALE                = 175,
    HSF_R2G2B2A2_UNORM            = 176,
    HSF_R8_TYPELESS               = 177,
    HSF_R8_UNORM                  = 178,
    HSF_R8_UINT                   = 179,
    HSF_R8_SNORM                  = 180,
    HSF_R8_SINT                   = 181,
    HSF_R8_USCALE                 = 182,
    HSF_R8_SSCALE                 = 183,
    HSF_A8_UNORM                  = 184,
    HSF_L8_UNORM                  = 185,
    HSF_A12_UNORM                 = 186,
    HSF_A4_UNORM                  = 187,
    HSF_R1_UNORM                  = 188,
    HSF_R3G3B2_UNORM              = 189,
    HSF_L4A4_UNORM                = 190,		
    HSF_A4L4_UNORM                = 191,
    HSF_L4A4_VIDEO                = 192,
    HSF_AYUV_VIDEO                = 193,		
    HSF_YUYV                      = 194,		
    HSF_NV12                      = 195,		
    HSF_P010                      = 196,        
    HSF_P016                      = 197,		
    HSF_R9G9B9E5_SHAREDEXP        = 198,
    HSF_R8G8_B8G8_UNORM           = 199,
    HSF_G8R8_G8B8_UNORM           = 200,
    HSF_BC1_UNORM                 = 201,
    HSF_BC1_UNORM_SRGB            = 202,
    HSF_BC2_UNORM                 = 203,
    HSF_BC2_UNORM_SRGB            = 204,
    HSF_BC3_UNORM                 = 205,
    HSF_BC3_UNORM_SRGB            = 206,
    HSF_BC4_UNORM                 = 207,
    HSF_BC4_SNORM                 = 208,
    HSF_BC4_UNORM_L               = 209,
    HSF_BC4_SNORM_L               = 210,
    HSF_BC5_UNORM                 = 211,
    HSF_BC5_SNORM                 = 212,
    HSF_BC5_UNORM_LA              = 213,
    HSF_BC5_SNORM_LA              = 214,
    HSF_BC6H_UF16                 = 215,
    HSF_BC6H_SF16                 = 216,
    HSF_BC7_UNORM                 = 217,
    HSF_BC7_UNORM_SRGB            = 218,
    HSF_G8_UINT                   = 219,
    HSF_3DC_UNORM                 = 220,
    HSF_YUY2                      = 221,		
    HSF_Y216_VIDEO                = 222,
    HSF_Y210_VIDEO                = 223,
    HSF_A4I4_VIDEO                = 224,
    HSF_A8L8_UNORM                = 225,
    HSF_L8A8_UNORM                = 226,
    HSF_ZL1                       = 227,
    HSF_R16G16B16A16_UNORM_SRGB   = 228,  
    HSF_YCRCB_MB_8_422            = 229,
    HSF_YCRCB_MB_8_420           = 230,
    HSF_YCRCB_MB_16_422           = 231,
    HSF_UYVA1010102_VIDEO         = 233,
    HSF_UYVY                      = 234,
    HSF_BAYER_12                  = 235,
    HSF_BAYER                     = 236,
    HSF_L8_SNORM                  = 237, 
    HSF_YV12                      = 238,
    HSF_L8A8_SNORM                = 239, 
    HSF_S1_UINT                   = 240,
    HSF_S16_UINT                  = 241,
    HSF_S4_UINT                   = 242,
    HSF_S8_UINT                   = 243,
    HSF_I12_UNORM                 = 244,
    HSF_I16_UNORM                 = 245,
    HSF_I4_UNORM                  = 246,
    HSF_I8_UNORM                  = 247,
    HSF_L12_UNORM                 = 248,
    HSF_L12_A12_UNORM             = 249,
    HSF_L12_A4_UNORM              = 250,
    HSF_L4_UNORM                  = 252,
    HSF_L4_A4_UNORM               = 253,
    HSF_L6_A2_UNORM               = 254,
    HSF_RGB8_ETC2                            = 255,
    HSF_SRGB8_ETC2                           = 256,
    HSF_RGBA8_ETC2_EAC                       = 257,
    HSF_SRGB8_ALPHA8_ETC2_EAC                = 258,
    HSF_R11_EAC                              = 259,
    HSF_RG11_EAC                             = 260,
    HSF_SIGNED_R11_EAC                       = 261,
    HSF_SIGNED_RG11_EAC                      = 262,
    HSF_RGB8_PUNCHTHROUGH_ALPHA1_ETC2        = 263,
    HSF_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2       = 264,
    HSF_COMPRESSED_ALPHA                     = 265,
    HSF_COMPRESSED_INTENSITY                 = 266,
    HSF_COMPRESSED_LUMINANCE                 = 267,
    HSF_COMPRESSED_RED                       = 268,
    HSF_COMPRESSED_RED_RGTC1                 = 269,
    HSF_COMPRESSED_RG                        = 270,
    HSF_COMPRESSED_RG_RGTC2                  = 271,
    HSF_COMPRESSED_RGB                       = 272,
    HSF_COMPRESSED_RGB_BPTC_SIGNED_FLOAT     = 273,
    HSF_COMPRESSED_RGB_BPTC_UNSIGNED_FLOAT   = 274,
    HSF_COMPRESSED_RGBA                      = 275,
    HSF_COMPRESSED_RGBA_BPTC_UNORM           = 276,
    HSF_COMPRESSED_SIGNED_RED_RGTC1          = 277,
    HSF_COMPRESSED_SIGNED_RG_RGTC2           = 278,
    HSF_COMPRESSED_SLUMINANCE                = 279,
    HSF_COMPRESSED_SLUMINANCE_ALPHA          = 280,
    HSF_COMPRESSED_SRGB                      = 281,
    HSF_COMPRESSED_SRGB_ALPHA                = 282,
    HSF_COMPRESSED_SRGB_ALPHA_BPTC_UNORM     = 283,
    HSF_R10G10B10A2_USCALE                   = 284,
    HSF_R10G10B10A2_SSCALE                   = 285,
    HSF_R32G32B32A32_SSCALE                  = 286,
    HSF_R32G32B32_SSCALE                     = 287,
    HSF_R32G32_SSCALE                        = 288,
    HSF_R16G16B16_SSCALE                     = 289,
    HSF_R32_SSCALE                           = 290,
    HSF_R8G8B8_SSCALE                        = 291,

    HSF_RGBA_ASTC_4X4                        = 321, 
    HSF_RGBA_ASTC_5X4                        = 322, 
    HSF_RGBA_ASTC_5X5                        = 323, 
    HSF_RGBA_ASTC_6X5                        = 324, 
    HSF_RGBA_ASTC_6X6                        = 325, 
    HSF_RGBA_ASTC_8X5                        = 326, 
    HSF_RGBA_ASTC_8X6                        = 327, 
    HSF_RGBA_ASTC_8X8                        = 328, 
    HSF_RGBA_ASTC_10X5                       = 329, 
    HSF_RGBA_ASTC_10X6                       = 330, 
    HSF_RGBA_ASTC_10X8                       = 331, 
    HSF_RGBA_ASTC_10X10                      = 332, 
    HSF_RGBA_ASTC_12X10                      = 333, 
    HSF_RGBA_ASTC_12X12                      = 334, 
    HSF_ASTC_RESERVED0                            = 335, 
    HSF_ASTC_RESERVED1                            = 336, 
    HSF_RGBA_ASTC_4X4_SRGB                   = 337, 
    HSF_RGBA_ASTC_5X4_SRGB                   = 338, 
    HSF_RGBA_ASTC_5X5_SRGB                   = 339, 
    HSF_RGBA_ASTC_6X5_SRGB                   = 340, 
    HSF_RGBA_ASTC_6X6_SRGB                   = 341, 
    HSF_RGBA_ASTC_8X5_SRGB                   = 342, 
    HSF_RGBA_ASTC_8X6_SRGB                   = 343, 
    HSF_RGBA_ASTC_8X8_SRGB                   = 344, 
    HSF_RGBA_ASTC_10X5_SRGB                  = 345, 
    HSF_RGBA_ASTC_10X6_SRGB                  = 346, 
    HSF_RGBA_ASTC_10X8_SRGB                  = 347, 
    HSF_RGBA_ASTC_10X10_SRGB                 = 348, 
    HSF_RGBA_ASTC_12X10_SRGB                 = 349, 
    HSF_RGBA_ASTC_12X12_SRGB                 = 350,
	HSF_R8G8B8_SRGB                          = 351, 
    HSF_ASTC_RESERVED3                            = 352,
    HSF_RGBA_ASTC_3x3x3                      = 353, 
    HSF_RGBA_ASTC_4x3x3                      = 354, 
    HSF_RGBA_ASTC_4x4x3                      = 355, 
    HSF_RGBA_ASTC_4x4x4                      = 356, 
    HSF_RGBA_ASTC_5x4x4                      = 357, 
    HSF_RGBA_ASTC_5x5x4                      = 358,
    HSF_RGBA_ASTC_5x5x5                      = 359,
    HSF_RGBA_ASTC_6x5x5                      = 360, 
    HSF_RGBA_ASTC_6x6x5                      = 361, 
    HSF_RGBA_ASTC_6x6x6                      = 362,
    HSF_L16A16_UNORM                         = 363, 
    HSF_L16A16_SNORM                         = 364, 
    HSF_ASTC_RESERVED6                            = 365,
    HSF_ASTC_RESERVED7                            = 366,
    HSF_ASTC_RESERVED8                            = 367,
    HSF_ASTC_RESERVED9                            = 368,
    HSF_RGBA_ASTC_3x3x3_SRGB                 = 369, 
    HSF_RGBA_ASTC_4x3x3_SRGB                 = 370, 
    HSF_RGBA_ASTC_4x4x3_SRGB                 = 371, 
    HSF_RGBA_ASTC_4x4x4_SRGB                 = 372, 
    HSF_RGBA_ASTC_5x4x4_SRGB                 = 373, 
    HSF_RGBA_ASTC_5x5x4_SRGB                 = 374,
    HSF_RGBA_ASTC_5x5x5_SRGB                 = 375,
    HSF_RGBA_ASTC_6x5x5_SRGB                 = 376, 
    HSF_RGBA_ASTC_6x6x5_SRGB                 = 377, 
    HSF_RGBA_ASTC_6x6x6_SRGB                 = 378,
    HSF_R64_UINT                             = 379,
    HSF_R64G64_UINT                          = 380,
    HSF_R64G64B64_UINT                       = 381,
    HSF_R64G64B64A64_UINT                    = 382,
    HSF_R64_SINT                             = 383,
    HSF_R64G64_SINT                          = 384,
    HSF_R64G64B64_SINT                       = 385,
    HSF_R64G64B64A64_SINT                    = 386,
    HSF_R4G4B4X4_UNORM                       = 387,
    HSF_R5G5B5X1_UNORM                       = 388,
    HSF_R8G8B8X8_SNORM                       = 389,
    HSF_R8G8B8X8_UINT                        = 390,
    HSF_R8G8B8X8_SINT                        = 391,
    HSF_R8G8B8X8_UNORM_SRGB                  = 392,
    HSF_R10G10B10X2_UNORM                    = 393,
    HSF_R16G16B16X16_UNORM                   = 394,
    HSF_R16G16B16X16_SNORM                   = 395,
    HSF_R16G16B16X16_FLOAT                   = 396,
    HSF_R16G16B16X16_UINT                    = 397,
    HSF_R16G16B16X16_SINT                    = 398,
    HSF_R32G32B32X32_FLOAT                   = 399,
    HSF_R32G32B32X32_UINT                    = 400,
    HSF_R32G32B32X32_SINT                    = 401,
    HSF_S8_UINT_D24_UNORM                    = 402, 
    HSF_D24_UNORM_S8_UINT                    = 403, 
    HSF_S8_UINT_D32_FLOAT                    = 404,

    HSF_R24_UNORM                            = 405,
    HSF_R24G24_UNORM                         = 406,
    HSF_R24G24B24A24_UNORM                   = 407,
    HSF_R10G10B10A10_UNORM                   = 408,
    HSF_BC1_TYPELESS                         = 409,

    HSF_B8G8R8A8_TYPELESS                    = 410,
    HSF_B8G8R8X8_TYPELESS                    = 411,
    HSF_BC2_TYPELESS                         = 412,
    HSF_BC3_TYPELESS                         = 413,
    HSF_BC4_TYPELESS                         = 414,
    HSF_BC5_TYPELESS                         = 415,
    HSF_BC6H_TYPELESS                        = 416,
    HSF_BC7_TYPELESS                         = 417,

} Hw_Surf_Format;

typedef enum COMPRESS_MXUFORMAT
{
    CP_OFF                  = 0,        
    CP_R8G8B8A8_T           = 1,        
    CP_R8G8B8A8_L           = 2,        
    CP_A8R8G8B8_T           = 3,        
    CP_A8R8G8B8_L           = 4,        
    CP_R10G10B10A2          = 5,        
    CP_A2B10G10R10          = 6,        
    CP_R11G11B10            = 7,        
    CP_R5G6B5               = 8,        
    CP_NV12                 = 9,        
    CP_YUYV                 = 10,       
    CP_UYVY                 = 11,       
	CP_R10G10B10A2_T        = 12,       
	CP_A2B10G10R10_T        = 13,       
	CP_NV12_10              = 14,       
	CP_Z32                  = 15,       
	CP_R16G16B16A16_T       = 16,       
    CP_Z16                  = 17,       
    CP_Z24                  = 18,       
	CP_R11G11B10_T          = 19,       
    CP_RGBAX8888_TILE_4X    = 20,       
    CP_XARGB8888_TILE_4X    = 21,       
    CP_Z16_4X               = 22,       
    CP_Z24_4X               = 23,       
    CP_Z32_4X               = 24,       
    CP_RGBAX8888_TILE_2X    = 25,       
    CP_XARGB8888_TILE_2X    = 26,       
    CP_Z16_2X               = 27,       
    CP_Z24_2X               = 28,       
    CP_Z32_2X               = 29,       
    CP_RGBAX8888_TILE_8X    = 30,       
    CP_XARGB8888_TILE_8X    = 31,       
    CP_Z16_8X               = 32,       
    CP_Z24_8X               = 33,       
    CP_Z32_8X               = 34,       
    CP_BAYER                = 35,       
    CP_R32G32B32A32_TILE    = 36,       
    CP_RGBAX8888_TILE_16X   = 37,       
    CP_XARGB8888_TILE_16X   = 38,       
    CP_Z16_16X              = 39,       
    CP_Z24_16X              = 40,       
    CP_Z32_16X              = 41,       
    CP_TOTAL_RANGE          = 42,       
}COMPRESS_MXUFORMAT;

#define BIT_COUNT_TABLE \
{\
    8,      \
    256,    \
    192,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    48,     \
    48,     \
    48,     \
    48,     \
    48,     \
    48,     \
    48,     \
    48,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    36,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    30,     \
    30,     \
    30,     \
    30,     \
    30,     \
    30,     \
    20,     \
    20,     \
    20,     \
    20,     \
    20,     \
    20,     \
    32,     \
    32,     \
    32,     \
    22,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    24,     \
    24,     \
    24,     \
    24,     \
    24,     \
    24,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    40,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    16,     \
    12,     \
    15,     \
    16,     \
    16,     \
    16,     \
    10,     \
    10,     \
    10,     \
    10,     \
    10,     \
    10,     \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    8,      \
    12,      \
    4,      \
    1,      \
    8,      \
    8,      \
    8,      \
    8,      \
    32,     \
    16,     \
    8,      \
    16,      \
    16,      \
    32,     \
    16,     \
    16,     \
    64,     \
    64,     \
    128,    \
    128,    \
    128,    \
    128,    \
    64,     \
    64,     \
    64,     \
    64,     \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    8,      \
    128,    \
    16,      \
    32,     \
    32,     \
    8,      \
    16,     \
    16,     \
    0,      \
    64,      \
    0,      \
    0,      \
    0,      \
    16,     \
    32,     \
    16,     \
    16,     \
    16,     \
    16,     \
    8,      \
    16,      \
    1,      \
    16,      \
    4,      \
    8,      \
    0,      \
    16,      \
    0,      \
    8,      \
    0,      \
    0,      \
    0,      \
    32,      \
    0,      \
    0,      \
    0,      \
    64,     \
    64,     \
    128,    \
    128,    \
    64,     \
    128,    \
    64,     \
    128,    \
    64,     \
    64,     \
    0,      \
    0,      \
    0,      \
    0,      \
    64,      \
    0,      \
    128,      \
    0,      \
    128,      \
    128,      \
    0,      \
    128,      \
    64,      \
    128,      \
    0,      \
    0,      \
    0,      \
    0,      \
    128,      \
    32,     \
    32,     \
    128,    \
    128,     \
    64,     \
    48,     \
    32,     \
    24,     \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    0,      \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    0,      \
    0,      \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    0,      \
    0,      \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    32,      \
    32,      \
    0,      \
    0,      \
    0,      \
    0,      \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    128,    \
    64,     \
    128,    \
    192,    \
    256,    \
    64,     \
    128,    \
    192,    \
    256,    \
    16,     \
    16,     \
    32,     \
    32,     \
    32,     \
    32,     \
    32,     \
    64,     \
    64,     \
    64,     \
    64,     \
    64,     \
    128,    \
    128,    \
    128,    \
    32,     \
    32,     \
    64,     \
    32,     \
    64,     \
    128,    \
    64,     \
    64,     \
    32,     \
    32,     \
    128,    \
    128,    \
    64,     \
    128,    \
    128,    \
    128,    \
    }\

#define SURFACE_FORMAT_MODE_E3K \
   {\
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UINT32, \
   PS_OUT_FMT_O0_DATA_FMT_SINT32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UINT32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP16, \
   PS_OUT_FMT_O0_DATA_FMT_FP16, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16, \
   PS_OUT_FMT_O0_DATA_FMT_UINT16, \
   PS_OUT_FMT_O0_DATA_FMT_SNORM16, \
   PS_OUT_FMT_O0_DATA_FMT_SINT16, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16, \
   PS_OUT_FMT_O0_DATA_FMT_FP16, \
   PS_OUT_FMT_O0_DATA_FMT_SINT16, \
   PS_OUT_FMT_O0_DATA_FMT_SNORM16, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UINT16, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UINT32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UINT16, \
   PS_OUT_FMT_O0_DATA_FMT_UINT16, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP16, \
   PS_OUT_FMT_O0_DATA_FMT_FP32, \
   PS_OUT_FMT_O0_DATA_FMT_FP16, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8, \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8, \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_SNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_SINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_SINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_SNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_UINT16,     \
   PS_OUT_FMT_O0_DATA_FMT_SNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_SINT16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM24,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_SNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_SINT8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_UINT16,     \
   PS_OUT_FMT_O0_DATA_FMT_SNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_SINT16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_UINT8,      \
   PS_OUT_FMT_O0_DATA_FMT_SNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_SINT8,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,    \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_UINT8,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM10,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM16,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP16,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_FP32,     \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED, \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_FP32,    \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED, \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED, \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_FP16,    \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_FP32,      \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_RESERVED,  \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
   PS_OUT_FMT_O0_DATA_FMT_FP16,      \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,      \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_UNORM8,     \
    PS_OUT_FMT_O0_DATA_FMT_UNORM8,      \
    PS_OUT_FMT_O0_DATA_FMT_SNORM8,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT8,     \
    PS_OUT_FMT_O0_DATA_FMT_SINT8,      \
    PS_OUT_FMT_O0_DATA_FMT_FP16,     \
    PS_OUT_FMT_O0_DATA_FMT_UNORM10,     \
    PS_OUT_FMT_O0_DATA_FMT_UNORM16,     \
    PS_OUT_FMT_O0_DATA_FMT_SNORM16,     \
    PS_OUT_FMT_O0_DATA_FMT_FP16,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT16,     \
    PS_OUT_FMT_O0_DATA_FMT_SINT16,     \
    PS_OUT_FMT_O0_DATA_FMT_FP32,     \
    PS_OUT_FMT_O0_DATA_FMT_UINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_SINT32,     \
    PS_OUT_FMT_O0_DATA_FMT_FP32,     \
    PS_OUT_FMT_O0_DATA_FMT_FP32,     \
    PS_OUT_FMT_O0_DATA_FMT_FP32,     \
    PS_OUT_FMT_O0_DATA_FMT_UNORM24,      \
    PS_OUT_FMT_O0_DATA_FMT_UNORM24,      \
    PS_OUT_FMT_O0_DATA_FMT_UNORM24,      \
    PS_OUT_FMT_O0_DATA_FMT_UNORM10,      \
    PS_OUT_FMT_O0_DATA_FMT_FP16,         \
    PS_OUT_FMT_O0_DATA_FMT_UNORM8,        \
    PS_OUT_FMT_O0_DATA_FMT_UNORM8,        \
    PS_OUT_FMT_O0_DATA_FMT_FP16,          \
    PS_OUT_FMT_O0_DATA_FMT_FP16,          \
    PS_OUT_FMT_O0_DATA_FMT_FP16,          \
    PS_OUT_FMT_O0_DATA_FMT_FP32,          \
    PS_OUT_FMT_O0_DATA_FMT_FP32,          \
    PS_OUT_FMT_O0_DATA_FMT_FP32,          \
   }
#define SURFACE_FORMAT_MODE_CHX004 \
   {\
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8, \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM24,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_SINT8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED, \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED, \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED, \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,    \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP32,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_RESERVED,  \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
   PS_OUT_RTFMT_RT0_DATA_FMT_FP16,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_SNORM8,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT8,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT8,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_SNORM16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT16,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_SINT32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,     \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM24,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM24,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM24,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM10,      \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,         \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,        \
    PS_OUT_RTFMT_RT0_DATA_FMT_UNORM8,        \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,          \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,          \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP16,          \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,          \
    PS_OUT_RTFMT_RT0_DATA_FMT_FP32,          \
    PS_OUT_FMT_O0_DATA_FMT_FP32,             \
   }
#define UAV_FORMAT \
{\
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_FP32, \
    CS_U_FMT_U0_DATA_FMT_UINT32, \
    CS_U_FMT_U0_DATA_FMT_SINT32, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_FP16, \
    CS_U_FMT_U0_DATA_FMT_UNORM16, \
    CS_U_FMT_U0_DATA_FMT_UINT16, \
    CS_U_FMT_U0_DATA_FMT_SNORM16, \
    CS_U_FMT_U0_DATA_FMT_SINT16, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_UINT16, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_FP32, \
    CS_U_FMT_U0_DATA_FMT_UINT32, \
    CS_U_FMT_U0_DATA_FMT_SINT32, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_UNORM10, \
    CS_U_FMT_U0_DATA_FMT_UINT16, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_UNORM10, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_UNORM10, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_FP16,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_UNORM8, \
    CS_U_FMT_U0_DATA_FMT_UNORM8,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM8,     \
    CS_U_FMT_U0_DATA_FMT_UNORM8,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM8,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UINT8,     \
    CS_U_FMT_U0_DATA_FMT_SNORM8,     \
    CS_U_FMT_U0_DATA_FMT_SINT8,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_FP16,     \
    CS_U_FMT_U0_DATA_FMT_UNORM16,     \
    CS_U_FMT_U0_DATA_FMT_UINT16,     \
    CS_U_FMT_U0_DATA_FMT_SNORM16,     \
    CS_U_FMT_U0_DATA_FMT_SINT16,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_FP32,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_FP32,     \
    CS_U_FMT_U0_DATA_FMT_UINT32,     \
    CS_U_FMT_U0_DATA_FMT_SINT32,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM8,     \
    CS_U_FMT_U0_DATA_FMT_UINT8,     \
    CS_U_FMT_U0_DATA_FMT_SNORM8,     \
    CS_U_FMT_U0_DATA_FMT_SINT8,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_FP16,     \
    CS_U_FMT_U0_DATA_FMT_UNORM16,     \
    CS_U_FMT_U0_DATA_FMT_UNORM16,     \
    CS_U_FMT_U0_DATA_FMT_UINT16,     \
    CS_U_FMT_U0_DATA_FMT_SNORM16,     \
    CS_U_FMT_U0_DATA_FMT_SINT16,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM16,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM10,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_UNORM8,      \
    CS_U_FMT_U0_DATA_FMT_UINT8,      \
    CS_U_FMT_U0_DATA_FMT_SNORM8,      \
    CS_U_FMT_U0_DATA_FMT_SINT8,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_UNORM8,      \
    CS_U_FMT_U0_DATA_FMT_UNORM8,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED, \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,    \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,  \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_UINT64,     \
    CS_U_FMT_U0_DATA_FMT_UINT64,     \
    CS_U_FMT_U0_DATA_FMT_UINT64,     \
    CS_U_FMT_U0_DATA_FMT_UINT64,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_UNORM24,      \
    CS_U_FMT_U0_DATA_FMT_UNORM24,      \
    CS_U_FMT_U0_DATA_FMT_UNORM24,      \
    CS_U_FMT_U0_DATA_FMT_UNORM10,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,     \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
    CS_U_FMT_U0_DATA_FMT_RESERVED,      \
}

typedef enum                   
{
    DS_NONE                = 0,                    
    S8_UINT                = 0x1,
    D16_UNORM              = 0x2,                  
    D24_UNORM              = 0x4,                  
    D32_FLOAT              = 0x8,
    D24_UNORM_S8_UINT      = D24_UNORM | S8_UINT,  
    D32_FLOAT_S8_UINT      = D32_FLOAT | S8_UINT,  
} DEPTH_STENCIL_FORMAT;

#define CHANNEL_MASK_R              1
#define CHANNEL_MASK_G              2
#define CHANNEL_MASK_B              4
#define CHANNEL_MASK_A              8
#define CHANNEL_MASK_X              16

typedef enum CHANNEL_MASK
{
    C_NONE                 = 0,
    C_R                    = CHANNEL_MASK_R,
    C_A                    = CHANNEL_MASK_A,
    C_GR                   = CHANNEL_MASK_G | CHANNEL_MASK_R,
    C_BGR                  = CHANNEL_MASK_B | CHANNEL_MASK_G | CHANNEL_MASK_R,
    C_BGRA                 = CHANNEL_MASK_B | CHANNEL_MASK_G | CHANNEL_MASK_R | CHANNEL_MASK_A,
    C_RGBX                 = CHANNEL_MASK_R | CHANNEL_MASK_G | CHANNEL_MASK_B | CHANNEL_MASK_X,
} CHANNEL_MASK;

typedef struct HWFORMAT_TABLE_ENTRY_E3K
{
    Hw_Surf_Format        MappedDstFormat;
    Hw_Surf_Format        Mapped2DDstFormat;
    Hw_Surf_Format        SuppressAlphaFormat;
    DEPTH_STENCIL_FORMAT  CompatibleDsFmt;
    COMPRESS_MXUFORMAT    CompressFmt;
    BYTE                  ChannelMask;
    BYTE                  bRtSupport;             
    BYTE                  bBlockCompressed;       
    BYTE                  bYUY2;                  
    BYTE                  b96bpp;                 
    BYTE                  bUnorm;                 
    BYTE                  bSnorm;                 
    BYTE                  bSrgb;                  
    BYTE                  bTypeless;              
    BYTE                  bTexBuf3channel;        
    BYTE                  bFP32Mode;              
    BYTE                  bASTC;                  
    BYTE                  BlockWidth;             
    BYTE                  BlockHeight;            
    BYTE                  BlockDepth;             
    BYTE                  ClrLineNum;             
} HWFORMAT_TABLE_ENTRY_E3K;

extern const HWFORMAT_TABLE_ENTRY_E3K g_HwFormatTable[];
#endif

