#ifndef __PM_DFS_E3K_H__

#include "zx_adapter.h"
#include "vidsch.h"
#include "vidschi.h"
#include "chip_include_e3k.h"

void vidsch_dfs_init_e3k(adapter_t *adapter);
void vidschi_init_dvfs_setting_004(adapter_t *adapter);
void vidsch_disable_dvfs_004(adapter_t *adapter);

int vidsch_dfs_set_e3k(adapter_t *adapter, zx_dvfs_set_t *dfs_set);
void vidsch_dfs_tuning_e3k(adapter_t *adapter);

int vidsch_power_clock_on_off_e3k(vidsch_mgr_t *sch_mgr, unsigned int off);
void vidsch_power_tuning_e3k(adapter_t *adapter);
int vidsch_query_dfs_clamp_e3k(adapter_t *adapter, zx_dvfs_clamp_status_t *dfs_clamp);

void vidsch_pll_on_off_e3k(adapter_t* adapter, unsigned int pll_on);
void vidsch_pll_tuning_e3k(adapter_t *adapter);
#endif
