#ifndef __VIDSCH_SUBMIT_H__
#define __VIDSCH_SUBMIT_H__

extern int  vidschi_prepare_and_submit_dma(vidsch_mgr_t *sch_mgr, task_dma_t *task_dma);
extern void vidschi_fake_submit_dma(vidsch_mgr_t *sch_mgr, task_dma_t *task_dma, int discard);

extern void vidschi_release_allocated_tasks(vidsch_mgr_t *sch_mgr);
extern task_desc_t *vidschi_uncompleted_task_exceed_wait_time(vidsch_mgr_t *sch_mgr, unsigned long long max_wait_time);

extern void vidschi_set_dma_task_submitted(vidsch_mgr_t *sch_mgr, task_desc_t *task);
extern void vidschi_set_dma_task_fake_submitted(vidsch_mgr_t *sch_mgr, task_desc_t *task);
extern void vidschi_set_uncompleted_task_dropped(vidsch_mgr_t *sch_mgr, unsigned long long dropped_task);

#endif

